src/Packagist/WebBundle/Entity/User.php
<?php

/*
 * This file is part of Packagist.
 *
 * (c) Jordi Boggiano <j.boggiano@seld.be>
 *     Nils Adermann <naderman@naderman.de>
 *
 * For the full copyright and license information, please view the LICENSE
 * file that was distributed with this source code.
 */

namespace Packagist\WebBundle\Entity;

use Doctrine\Common\Collections\ArrayCollection;
use Doctrine\ORM\Mapping as ORM;
use Scheb\TwoFactorBundle\Model\BackupCodeInterface;
use Scheb\TwoFactorBundle\Model\Totp\TwoFactorInterface;
use Scheb\TwoFactorBundle\Model\Totp\TotpConfigurationInterface;
use Scheb\TwoFactorBundle\Model\Totp\TotpConfiguration;
use Symfony\Component\Validator\Constraints as Assert;
use FOS\UserBundle\Model\User as BaseUser;

/**
 * @ORM\Entity(repositoryClass="Packagist\WebBundle\Entity\UserRepository")
 * @ORM\Table(name="fos_user")
 * @ORM\AttributeOverrides({
 *     @ORM\AttributeOverride(name="username",
 *         column=@ORM\Column(
 *             name="username",
 *             type="string",
 *             length=191
 *         )
 *     ),
 *     @ORM\AttributeOverride(name="usernameCanonical",
 *         column=@ORM\Column(
 *             name="username_canonical",
 *             type="string",
 *             length=191,
 *             unique=true
 *         )
 *     ),
 *     @ORM\AttributeOverride(name="email",
 *         column=@ORM\Column(
 *             name="email",
 *             type="string",
 *             length=191
 *         )
 *     ),
 *     @ORM\AttributeOverride(name="emailCanonical",
 *         column=@ORM\Column(
 *             name="email_canonical",
 *             type="string",
 *             length=191,
 *             unique=true
 *         )
 *     )
 * })
 */
class User extends BaseUser implements TwoFactorInterface, BackupCodeInterface
{
    /**
     * @ORM\Id
     * @ORM\Column(type="integer")
     * @ORM\GeneratedValue(strategy="AUTO")
     */
    protected $id;

    /**
     * @Assert\Length(
     *     min=2,
     *     max=180,
     *     groups={"Profile", "Registration"}
     * )
     * @Assert\Regex(
     *     pattern="{^[^/""\r\n><#\[\]]{2,100}$}",
     *     message="Username invalid, /""\r\n><#[] are not allowed",
     *     groups={"Profile", "Registration"}
     * )
     * @Assert\NotBlank(
     *     message="fos_user.username.blank",
     *     groups={"Profile", "Registration"}
     * )
     */
    protected $username;

    /**
     * @ORM\ManyToMany(targetEntity="Package", mappedBy="maintainers")
     */
    private $packages;

    /**
     * @ORM\Column(type="datetime")
     */
    private $createdAt;

    /**
     * @ORM\Column(type="string", length=20, nullable=true)
     * @var string
     */
    private $apiToken;

    /**
     * @ORM\Column(type="string", length=255, nullable=true)
     * @var string
     */
    private $githubId;

    /**
     * @ORM\Column(type="string", length=255, nullable=true)
     * @var string
     */
    private $githubToken;

    /**
     * @ORM\Column(type="string", length=255, nullable=true)
     * @var string
     */
    private $githubScope;

    /**
     * @ORM\Column(type="boolean", options={"default"=true})
     * @var string
     */
    private $failureNotifications = true;

    /**
     * @ORM\Column(name="totpSecret", type="string", nullable=true)
     * @var string|null
     */
    private $totpSecret;

    /**
     * @ORM\Column(type="string", length=8, nullable=true)
     * @var string|null
     */
    private $backupCode;

    public function __construct()
    {
        $this->packages = new ArrayCollection();
        $this->createdAt = new \DateTime();
        parent::__construct();
    }

    public function toArray()
    {
        return array(
            'name' => $this->getUsername(),
            'avatar_url' => $this->getGravatarUrl(),
        );
    }

    /**
     * Add packages
     *
     * @param Package $packages
     */
    public function addPackages(Package $packages)
    {
        $this->packages[] = $packages;
    }

    /**
     * Get packages
     *
     * @return Package[]
     */
    public function getPackages()
    {
        return $this->packages;
    }

    /**
     * Set createdAt
     *
     * @param \DateTime $createdAt
     */
    public function setCreatedAt($createdAt)
    {
        $this->createdAt = $createdAt;
    }

    /**
     * Get createdAt
     *
     * @return \DateTime
     */
    public function getCreatedAt()
    {
        return $this->createdAt;
    }

    /**
     * Set apiToken
     *
     * @param string $apiToken
     */
    public function setApiToken($apiToken)
    {
        $this->apiToken = $apiToken;
    }

    /**
     * Get apiToken
     *
     * @return string
     */
    public function getApiToken()
    {
        return $this->apiToken;
    }

    /**
     * Get githubId.
     *
     * @return string
     */
    public function getGithubId()
    {
        return $this->githubId;
    }

    /**
     * Get githubId.
     *
     * @return string
     */
    public function getGithubUsername()
    {
        if ($this->githubId) {
            if (!$this->githubToken) {
                return false;
            }

            $ctxt = ['http' => ['header' => ['User-Agent: packagist.org', 'Authorization: token '.$this->githubToken]]];
            $res = @file_get_contents('https://api.github.com/user', false, stream_context_create($ctxt));
            if (!$res || !($res = json_decode($res, true))) {
                return false;
            }

            return $res['login'];
        }

        return false;
    }

    /**
     * Set githubId.
     *
     * @param string $githubId
     */
    public function setGithubId($githubId)
    {
        $this->githubId = $githubId;
    }

    /**
     * Get githubToken.
     *
     * @return string
     */
    public function getGithubToken()
    {
        return $this->githubToken;
    }

    /**
     * Set githubToken.
     *
     * @param string $githubToken
     */
    public function setGithubToken($githubToken)
    {
        $this->githubToken = $githubToken;
    }

    /**
     * Get githubScope.
     *
     * @return string
     */
    public function getGithubScope()
    {
        return $this->githubScope;
    }

    /**
     * Set githubScope.
     *
     * @param string $githubScope
     */
    public function setGithubScope($githubScope)
    {
        $this->githubScope = $githubScope;
    }

    /**
     * Set failureNotifications
     *
     * @param Boolean $failureNotifications
     */
    public function setFailureNotifications($failureNotifications)
    {
        $this->failureNotifications = $failureNotifications;
    }

    /**
     * Get failureNotifications
     *
     * @return Boolean
     */
    public function getFailureNotifications()
    {
        return $this->failureNotifications;
    }

    /**
     * Get failureNotifications
     *
     * @return Boolean
     */
    public function isNotifiableForFailures()
    {
        return $this->failureNotifications;
    }

    /**
     * Get Gravatar Url
     *
     * @return string
     */
    public function getGravatarUrl()
    {
        return 'https://www.gravatar.com/avatar/'.md5(strtolower($this->getEmail())).'?d=identicon';
    }

    public function setTotpSecret(?string $secret)
    {
        $this->totpSecret = $secret;
    }

    public function isTotpAuthenticationEnabled(): bool
    {
        return $this->totpSecret ? true : false;
    }

    public function getTotpAuthenticationUsername(): string
    {
        return $this->username;
    }

    public function getTotpAuthenticationConfiguration(): TotpConfigurationInterface
    {
        return new TotpConfiguration($this->totpSecret, TotpConfiguration::ALGORITHM_SHA1, 30, 6);
    }

    public function isBackupCode(string $code): bool
    {
        return $this->backupCode !== null && hash_equals($this->backupCode, $code);
    }

    public function invalidateBackupCode(string $code): void
    {
        $this->backupCode = null;
    }

    public function invalidateAllBackupCodes(): void
    {
        $this->backupCode = null;
    }

    public function setBackupCode(string $code): void
    {
        $this->backupCode = $code;
    }
}

src/Packagist/WebBundle/Resources/views/user/configure_two_factor_auth.html.twig
{% extends "PackagistWebBundle:user:packages.html.twig" %}

{% import "PackagistWebBundle::macros.html.twig" as macros %}

{% block content %}
    {% set isActualUser = app.user and app.user.username is same as(user.username) %}

    {% if backup_code %}
        <div class="alert alert-info">
            <p>If you lose your phone or otherwise can't get codes via your authenticator app, you can this one-time backup code to sign in: <code>{{ backup_code }}</code></p>
            <p><strong>Take a moment to record this in a safe place. This code will not be shown again!</strong></p>
        </div>
    {% endif %}

    <h2 class="title">
        {{ user.username }}
        {%- if not isActualUser %}
            <small>
                member since: {{ user.createdAt|date('M d, Y') }}
                {%- if is_granted('ROLE_ADMIN') %}
                    <a href="mailto:{{ user.email }}">{{ user.email }}</a>
                {%- endif %}
            </small>
        {%- endif %}
    </h2>

    <section class="row">
        {% if isActualUser %}
            <section class="col-md-3">
                {{ knp_menu_render('profile_menu', {currentClass: 'active', allow_safe_labels: true}) }}
            </section>
        {% endif %}

        <section class="{{ isActualUser ? 'col-md-9' : 'col-md-12' }}">
            {% if user.totpAuthenticationEnabled %}
                <p class="alert alert-success">
                    <span class="icon-lock"></span>
                    Two-factor authentication is currently <strong>enabled</strong>.
                </p>

                <p>Two-factor authentication is an extra layer of security for your Packagist account designed to ensure that you're the only person who can access your account, even if someone knows your password.</p>

                <a href="{{ path('user_2fa_disable', {name: user.username}) }}" class="text-danger">Disable two-factor authentication</a>
            {% else %}
                <p class="alert alert-warning">
                    <span class="icon-unlock"></span>
                    Two-factor authentication is currently <strong>disabled</strong>.
                </p>

                <p>Two-factor authentication is an extra layer of security for your Packagist account designed to ensure that you're the only person who can access your account, even if someone knows your password.</p>

                <a href="{{ path('user_2fa_enable', {name: user.username}) }}" class="btn btn-block btn-primary btn-lg">Enable two-factor authentication</a>
            {% endif %}
        </section>
    </section>
{% endblock %}

src/Packagist/WebBundle/Resources/views/user/confirm_two_factor_auth.html.twig
{% extends "PackagistWebBundle:user:packages.html.twig" %}

{% import "PackagistWebBundle::macros.html.twig" as macros %}

{% block content %}
    {% set isActualUser = app.user and app.user.username is same as(user.username) %}

    <h2 class="title">
        {{ user.username }}
        {%- if not isActualUser %}
            <small>
                member since: {{ user.createdAt|date('M d, Y') }}
                {%- if is_granted('ROLE_ADMIN') %}
                    <a href="mailto:{{ user.email }}">{{ user.email }}</a>
                {%- endif %}
            </small>
        {%- endif %}
    </h2>

    <section class="row">
        {% if isActualUser %}
            <section class="col-md-3">
                {{ knp_menu_render('profile_menu', {currentClass: 'active', allow_safe_labels: true}) }}
            </section>
        {% endif %}

        <section class="col-md-6">
            <h3>Save your backup code</h3>

            <div class="well well-lg">
                <p>A backup code will let you access your account if your phone is lost, stolen, or you otherwise can't generate codes via your authenticator app.  We ask that you save this unique, one-time use backup code in a safe place:</p>

                <kbd class="two-factor-backup-code">{{ backup_code }}</kbd>

                <p class="text-danger"><strong>Without access to your authenticator app or backup code, you will permanently lose access to your account.</strong></p>

                <p>To use the backup code, simply enter it during two-factor authentication where you'd normally enter a generated code.</p>

                <p>
                    Please take a moment to put this code in a safe place.
                    <strong>This code will not be shown again!</strong>
                </p>
            </div>

            <p>
                <a href="{{path('user_2fa_configure', {name: user.username})}}" class="btn btn-success btn-lg">
                    <span class="icon-check"></span>
                    I have saved the backup code
                </a>
            </p>
        </section>
    </section>
{% endblock %}

src/Packagist/WebBundle/Resources/views/user/disable_two_factor_auth.html.twig
{% extends "PackagistWebBundle:user:packages.html.twig" %}

{% import "PackagistWebBundle::macros.html.twig" as macros %}

{% block content %}
    {% set isActualUser = app.user and app.user.username is same as(user.username) %}

    <h2 class="title">
        {{ user.username }}
        {%- if not isActualUser %}
            <small>
                member since: {{ user.createdAt|date('M d, Y') }}
                {%- if is_granted('ROLE_ADMIN') %}
                    <a href="mailto:{{ user.email }}">{{ user.email }}</a>
                {%- endif %}
            </small>
        {%- endif %}
    </h2>

    <section class="row">
        {% if isActualUser %}
            <section class="col-md-3">
                {{ knp_menu_render('profile_menu', {currentClass: 'active', allow_safe_labels: true}) }}
            </section>
        {% endif %}

        <section class="{{ isActualUser ? 'col-md-9' : 'col-md-12' }}">
            <h3 class="text-danger">Are you sure you wish to disable two-factor authentication?</h3>

            <p>Your account is more secure when you need a password and a verification code to sign in. If you remove this extra layer of security, you will only be asked for a password when you sign in. It might be easier for someone to break into your account.</p>

            <p>If you'd like to proceed anyway, simply click the button below.</p>

            <div class="row">
                <div class="col-md-6">
                    <a class="btn btn-lg btn-inverse" href="{{ path('user_2fa_configure', {name: user.username}) }}">Nevermind, keep my account secure</a>
                </div>
                <div class="col-md-6">
                    <a href="{{ path('user_2fa_disable', {token: csrf_token('disable_2fa'), name: user.username}) }}" class="btn btn-block btn-danger btn-lg">
                        <span class="icon-lock-open"></span>
                        Disable two-factor authentication
                    </a>
                </div>
            </div>


        </section>
    </section>
{% endblock %}

src/Packagist/WebBundle/Resources/views/user/enable_two_factor_auth.html.twig
{% extends "PackagistWebBundle:user:packages.html.twig" %}

{% import "PackagistWebBundle::macros.html.twig" as macros %}

{% block content %}
    {% set isActualUser = app.user and app.user.username is same as(user.username) %}

    <h2 class="title">
        {{ user.username }}
        {%- if not isActualUser %}
            <small>
                member since: {{ user.createdAt|date('M d, Y') }}
                {%- if is_granted('ROLE_ADMIN') %}
                    <a href="mailto:{{ user.email }}">{{ user.email }}</a>
                {%- endif %}
            </small>
        {%- endif %}
    </h2>

    <section class="row">
        {% if isActualUser %}
            <section class="col-md-3">
                {{ knp_menu_render('profile_menu', {currentClass: 'active', allow_safe_labels: true}) }}
            </section>
        {% endif %}

        <section class="{{ isActualUser ? 'col-md-9' : 'col-md-12' }}">
            <p>
                To enable two-factor authentication, you'll need an app that supports TOTP such as
                <a href="https://authy.com/download/">Authy</a>,
                <a href="https://play.google.com/store/apps/details?id=com.google.android.apps.authenticator2">Google Authenticator</a>,
                or
                <a href="https://keepassxc.org/">KeePassXC</a>.
            </p>

            <p><small>(This is not an exhaustive list of compatible apps. Packagist does not endorse or recommend one application over another.)</small></p>

            <p class="pull-right two-factor-key">
                <img src="{{ qr_code_data_uri(provisioningUri) }}" height="200" />
                <br>
                <small>TOTP Key: <code>{{ secret }}</code></small>
            </p>

            <h3>Enabling Two-Factor Authentication</h3>

            <p>To enable two-factor authentication on your Packagist account:</p>

            <ol>
                <li>Open your authenticator app.</li>
                <li>Add an account within the app and scan the QR code shown here.</li>
                <li>Enter the code generated by your authenticator app below.</li>
            </ol>

            {{ form_start(form, {'attr': { 'class': 'col-md-6' } }) }}
                {{ form_errors(form) }}

                <div class="form-group clearfix">
                    {{ form_label(form.code, 'Code shown in authenticator:') }}
                    <div class="input-group">
                        {{ form_errors(form.code) }}
                        {{ form_widget(form.code) }}
                        <span class="input-group-addon"><span class="icon-key"></span></span>
                    </div>
                </div>

                <input type="submit" class="btn btn-block btn-inverse btn-lg" value="Enable Two-Factor Authentication" />
            {{ form_end(form) }}
        </section>
        </section>
    </section>
{% endblock %}

src/Packagist/WebBundle/Resources/views/user/favorites.html.twig
{% extends "PackagistWebBundle:user:packages.html.twig" %}

{% import "PackagistWebBundle::macros.html.twig" as macros %}

{% block content %}
{% set isActualUser = app.user and app.user.username is same as(user.username) %}

<h2 class="title">
    {{ user.username }}
    {%- if not isActualUser %}
        <small>
            member since: {{ user.createdAt|date('M d, Y') }}
            {%- if is_granted('ROLE_ADMIN') %}
                <a href="mailto:{{ user.email }}">{{ user.email }}</a>
            {%- endif %}
        </small>
    {%- endif %}
</h2>

<section class="row">
    {% if isActualUser %}
        <section class="col-md-3">
            {{ knp_menu_render('profile_menu', {currentClass: 'active', allow_safe_labels: true}) }}
        </section>
    {% endif %}

    <section class="{{ isActualUser ? 'col-md-9' : 'col-md-12' }}">
        {% embed "PackagistWebBundle:web:list.html.twig" with {noLayout: 'true', showAutoUpdateWarning: isActualUser} %}
            {% block content_title %}
                <h3 class="font-normal profile-title">{{ (isActualUser ? 'packages.my_favorites' : 'packages.users_favorites')|trans({ '%user%': user.username }) }}</h3>
            {% endblock %}
        {% endembed %}
    </section>
</section>
{% endblock %}

src/Packagist/WebBundle/Resources/views/user/packages.html.twig
{% extends "PackagistWebBundle::layout.html.twig" %}

{% import "PackagistWebBundle::macros.html.twig" as macros %}


{% block content %}
{% set isActualUser = app.user and app.user.username is same as(user.username) %}
<h2 class="title">
    {{ user.username }}
    {%- if not isActualUser %}
        <small>
            member since: {{ user.createdAt|date('M d, Y') }}
            {%- if is_granted('ROLE_ADMIN') %}
                <a href="mailto:{{ user.email }}">{{ user.email }}</a>
            {%- endif %}
        </small>
    {%- endif %}
</h2>

<section class="row">
    {% if isActualUser %}
        <section class="col-md-3">
            {{ knp_menu_render('profile_menu', {'currentClass': 'active', 'allow_safe_labels': true}) }}
        </section>
    {% endif %}

    <section class="{{ isActualUser ? 'col-md-9' : 'col-md-12' }}">
        {% embed "PackagistWebBundle:web:list.html.twig" with {noLayout: 'true', showAutoUpdateWarning: isActualUser} %}
            {% block content_title %}
                <h3 class="font-normal profile-title">{{ (isActualUser ? 'packages.mine' : 'packages.maintained_by')|trans({ '%user%': user.username }) }}</h3>
            {% endblock %}
        {% endembed %}
    </section>
</section>
{% endblock %}

src/Packagist/WebBundle/Resources/views/user/profile.html.twig
{% extends "PackagistWebBundle::layout.html.twig" %}

{% import "PackagistWebBundle::macros.html.twig" as macros %}

{% block head_additions %}
    {% if user.hasRole('ROLE_SPAMMER') %}
        <meta name="robots" content="noindex, nofollow">
    {% endif %}
{% endblock %}

{% block content %}
{% set isActualUser = app.user and app.user.username is same as(user.username) %}
<h2 class="title">
    {{ user.username }}
    <small>
        {% if is_granted('ROLE_ANTISPAM') and user.hasRole('ROLE_SPAMMER') %}
            [SPAMMER]
        {% endif %}
        {{ 'user.member_since'|trans }}: {{ user.createdAt|date('M d, Y') }}
        {%- if is_granted('ROLE_ADMIN') %}
            <a href="mailto:{{ user.email }}">{{ user.email }}</a>
        {%- endif %}
        {%- if deleteForm is defined and (is_granted('ROLE_ADMIN') or isActualUser) %}
            <form class="delete action" action="{{ path('user_delete', {name: user.username}) }}" method="POST">
                {{ form_widget(deleteForm._token) }}
                <input class="btn btn-danger" type="submit" value="Delete Account Permanently" onclick="return confirm('Are you sure? There is no way back..');" />
            </form>
        {%- endif %}
        {%- if is_granted('ROLE_ANTISPAM') %}
            <form class="delete action" action="{{ path('mark_spammer', {name: user.username}) }}" method="POST">
                {{ form_widget(spammerForm._token) }}
                <input class="btn btn-danger" type="submit" value="Mark as Spammer" />
            </form>
        {%- endif %}
    </small>
</h2>

<section class="row">
    <section class="col-md-12">
        {% embed "PackagistWebBundle:web:list.html.twig" with {noLayout: 'true', showAutoUpdateWarning: isActualUser} %}
            {% block content_title %}
                <h3 class="font-normal profile-title">{{ 'user.packages'|trans({ '%username%':user.username }) }}</h3>
            {% endblock %}
        {% endembed %}
    </section>
</section>
{% endblock %}